<%--
http://servername:8080/ViewServer/changeannotations.jsp?[annots=<path>&]file=<filename>&page=<pageno>&remove=<name1>+<name2>+...
--%><%@ page
   contentType="text/xml; charset=UTF-8"
   session="true"
   isThreadSafe="true"
   isErrorPage="false"
   import="javax.naming.*,
           javax.security.auth.login.LoginException,
           java.util.Vector,
           java.util.logging.Level,
           com.esko.util.StringUtils,
           com.esko.webcenter.log.LogMgr,
           com.esko.webcenter.jsp.LoginMgr,
           com.esko.webcenter.src.util.XMLUtils,com.esko.viewserver.ejb.interfaces.*"
%><%
response.setHeader("Content-Encoding", "gzip");
response.setContentType("text/xml; charset=UTF-8");
java.util.zip.GZIPOutputStream gzos = new java.util.zip.GZIPOutputStream(response.getOutputStream());
java.io.OutputStreamWriter writer = new java.io.OutputStreamWriter(gzos, "UTF-8");

String message = "";
try {
  if (!LoginMgr.getLoginMgr(session).isLoggedIn()) {
    throw new LoginException("Not logged in");
  }
  Integer pageId = new Integer(-1);
  String pageParam = request.getParameter("page");
  if (pageParam != null) {
    try {
      pageId = Integer.decode(pageParam);
    }
    catch (Exception e) {
    	LogMgr.getLogger(this.getClass()).log(Level.SEVERE, "Badly formed page parameter: " + pageParam,e);
    }
  }
  String reloadParam = request.getParameter("reload");
  Integer reload = new Integer(1);
  if (reloadParam != null) {
    try {
      reload = Integer.decode(reloadParam);
    }
    catch (Exception e) {
    	LogMgr.getLogger(this.getClass()).log(Level.SEVERE,"Badly formed page parameter: " +pageParam, e);
    }
  }
  String[] remove = request.getParameterValues("remove");
  Vector<String> vremove = null;
  if (remove!=null && remove.length>0) {
    vremove = new Vector<String>(remove.length);
    for (int i=0; i<remove.length; i++) {
      vremove.add(remove[i]);
    }
  }
  
  String source = null;
  int len = request.getContentLength();
  if (len > 10) {
    byte[] buf = new byte[request.getContentLength()];
    int read = 0;
    while (read < len) {
      int r = request.getInputStream().read(buf, read, len - read);
      if (r == -1) // EOD
        break;
      read += r;
    }
    // by default, start reading the byte array at index 0
    int startAt = 0;
    // if the BOM mark is present, skip the BOM mark, start reading at byte 3
    if (buf.length > 3 && buf[0] == (byte)0xEF && buf[1] == (byte)0xBB && buf[2] == (byte)0xBF){
    	startAt = 3;
    }
    source = new String(buf, startAt, buf.length-startAt, "UTF-8");
  }
  ImageTM imageTM = ViewServerJndiLookup.getInstance().getViewServerBean();
  String file = request.getParameter("annots");
  if (file == null || file.length()==0)
    file = imageTM.GetAnnotationFile(request.getQueryString());
  if (file != null && file.length()>0) {
	String username = StringUtils.checkForValue(LoginMgr.getLoginMgr(session).getDelegateUsername()) ? LoginMgr.getLoginMgr(session).getDelegateUsername() : LoginMgr.getLoginMgr(session).getUserName();
  	message = imageTM.ChangeAnnotations(file, vremove, source, pageId, username, (reload.intValue()>0));
  }
  else {
    message = "<status><value>-1</value><message>Failed to retrieve annotation file name!</message></status>";
  }
  
} // try
catch( Exception e ) {
  message = "<status><value>-1</value><message>"+XMLUtils.encodeXml(e.toString())+"</message></status>";
  LogMgr.getLogger(this.getClass()).log(Level.SEVERE,"changeannotations",e);
} // catch
if (message.length()>1) {
  writer.write(message);
  writer.flush();
  writer.close(); //needed for gzip writer only
}
%>